/**************************************/
/*                                    */
/*     Nagravision sound decoder      */
/*                                    */
/*          by  Galtor 1999           */
/*                                    */
/*         and by Keuleu 2000         */
/*                                    */
/*         MMX by Maupatz  2001       */
/**************************************/
/* MMX for do_audiodecode_44          */

#include "config.h"
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <math.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <sys/time.h>
#ifndef NOTHAVE_SEM 
#include <semaphore.h>
#endif
#include <dlfcn.h>
#ifndef RTLD_DEFAULT /* not defined on linux */
#define RTLD_DEFAULT NULL
#endif
#ifdef DL_ADD_UNDERSCORE
#define DL_UND(x) ("_" x)
#else
#define DL_UND(x) (x)
#endif

#ifdef HAVE_OSS
#ifdef HAVE_ALSA
#define ALSA_PCM_OLD_HW_PARAMS_API
#define ALSA_PCM_OLD_SW_PARAMS_API
# if defined(HAVE_SYS_ASOUNDLIB_H)
#   include <sys/asoundlib.h>
# elif defined(HAVE_ALSA_ASOUNDLIB_H)
#   include <alsa/asoundlib.h>
# endif
#endif
#ifdef HAVE_SUNAUDIO
#include <sys/audioio.h>
#else
#if defined(HAVE_LINUX_SOUNDCARD_H)
#include <linux/soundcard.h>
#elif defined(HAVE_SOUNDCARD_H)
#include <soundcard.h>
#elif defined(HAVE_SYS_SOUNDCARD_H)
#include <sys/soundcard.h>
#elif defined(HAVE_MACHINE_SOUNDCARD_H)
#include <machine/soundcard.h>
#endif
#endif

#include <sys/ioctl.h>
#endif

#include <pthread.h>

#include "nagraudio.h"
#ifdef WRITE_TO_WAV
#  include "wavhead.h"
#endif

#include "attributes.h"
#include "cpu_accel.h"
#include "memcpy.h"
#include "divx.h"

extern int debug;
extern int have_MMX;
extern double audiostamp;
extern int noaudioout;
extern int avi;
/* should be extern but static and loaded with dlsym for compatibilities...*/
#ifndef DL_NOAUTOSYM
static void (*avi_audio_stop)(void);
static void (*avi_audio_start)(void);
static int (*avi_extract_audiobuf)(void *);
#else
extern void avi_audio_stop(void);
extern void avi_audio_start(void);
extern int avi_extract_audiobuf(void *);
#endif
#ifndef NOTHAVE_SEM 
static sem_t *avi_sem_ptr;
#ifdef DL_NOAUTOSYM
extern sem_t avi_sem;
#endif
#else
extern pthread_mutex_t avi_mut,avi_mut2,*avi_mut_video;
#endif
/**** end false extern.....*/
int avi2;
int naudiofrags=-1,naudiofragsize=2048;
static void *audiobuf=NULL;

#undef WRITE_TO_WAV

/*******************************************/
/************ FILTER DEFINITION ************/
/*******************************************/

/* The user level n are internal n*2-1 level !! */


static int in_coef[MAX_ORDER + 1][MAX_ORDER] = {
  {}, {}, {}, {0, 3}, {}, {0, 5, 10}, {}, {0, 7, 21, 35}
};

/************ POST MODULATION FILTER DEFINITION **************/

static int post_out_coef[MAX_ORDER + 1][MAX_ORDER + 1] = {
  {},

  {0, 0.0731489272 * (1 << PRECISSION)},    //Level 1 

  {},

  {0, 0.2678654389 * (1 << PRECISSION), -0.3523244053 * (1 << PRECISSION),    //Level 3 
   0.0247302699 * (1 << PRECISSION)},

  {},

  {0, 0.4576942144 * (1 << PRECISSION), -0.7067341465 * (1 << PRECISSION),    //Level 5 
   0.1603017017 * (1 << PRECISSION), -0.0670410490 * (1 << PRECISSION),
   0.0043118519 * (1 << PRECISSION)},

  {},

  {0, 0.6455546255 * (1 << PRECISSION), -1.0827483976 * (1 << PRECISSION),    //Level 7
   0.4131654344 * (1 << PRECISSION), -0.2552919195 * (1 << PRECISSION),
   0.0500299877 * (1 << PRECISSION), -0.0111237227 * (1 << PRECISSION),
   0.0006362623 * (1 << PRECISSION)}
};


static int post_gains[MAX_ORDER + 1] = { 0,
  2.157843972 * (1 << PRECISSION), 0,
  7.549101979 * (1 << PRECISSION), 0,
  27.79062545 * (1 << PRECISSION), 0,
  103.2443130 * (1 << PRECISSION)
};


/************ PRE MODULATION FILTER DEFINITION ***************/

static int pre_out_coef[MAX_ORDER + 1][MAX_ORDER + 1] = {
  {},

  {0, -0.1416306738 * (1 << PRECISSION)},    //Level 1 

  {},

  {0, -0.5168039063 * (1 << PRECISSION), -0.4041813836 * (1 << PRECISSION),    //Level 3
   -0.0497187889 * (1 << PRECISSION)},

  {},

  {0, -0.8823852003 * (1 << PRECISSION), -0.9062925254 * (1 << PRECISSION),    //Level 5
   -0.3366224025 * (1 << PRECISSION), -0.0995725400 * (1 << PRECISSION),
   -0.0096268552 * (1 << PRECISSION)},

  {},

  {0, -1.2442434093 * (1 << PRECISSION), -1.5253656891 * (1 << PRECISSION),    //Level 7
   -0.9065143396 * (1 << PRECISSION), -0.4407574247 * (1 << PRECISSION),
   -0.1209858632 * (1 << PRECISSION), -0.0220286561 * (1 << PRECISSION),
   -0.0016585133 * (1 << PRECISSION)}
};

static int pre_gains[MAX_ORDER + 1] = { 0,
  1.751880048 * (1 << PRECISSION), 0,
  4.059462852 * (1 << PRECISSION), 0,
  9.893338913 * (1 << PRECISSION), 0,
  24.32741402 * (1 << PRECISSION)
};

/*********************************************/
/********** END OF FILTER DEFINITION *********/
/*********************************************/

/************** GLOBAL VARIABLES *************/

static int bits = 16;
static int DEC_FREQ;
static int OUT_GAIN = 0;        /* 0= no gain, 1= x2, 2= x4 ,3= x8 */

#ifdef HAVE_SUNAUDIO
static char device[20] = "/dev/sound";
#else
static char device[20] = "/dev/dsp";
#endif
#ifdef HAVE_OSS
#ifdef HAVE_ALSA
static snd_pcm_t *handle_in = NULL, *handle_out = NULL;    /* Alsa card handle */
extern int have_alsa;
#endif
static int fd = -1;
#endif

static int decode = 1;
static int auto_decode = 0;
static int pre_filter_level = 0;    /* 0, 1, 3, 5, 7 */
static int post_filter_level = 7;    /* 0, 1, 3, 5, 7 */
static pthread_t nagraudio_thread;
static pthread_mutex_t divx_mutex;

/*********************************************/

void
start_nagraudio (void)
{
  int arg = 0;                    /* do not read config file, already done by xawdecode */
  int ret;

#ifndef DL_NOAUTOSYM
  avi_audio_stop = dlsym(RTLD_DEFAULT,DL_UND("avi_audio_stop"));
  avi_audio_start = dlsym(RTLD_DEFAULT,DL_UND("avi_audio_start"));
  avi_extract_audiobuf = dlsym(RTLD_DEFAULT,DL_UND("avi_extract_audiobuf"));
#endif
#ifndef NOTHAVE_SEM
#ifdef DL_NOAUTOSYM
  avi_sem_ptr = &avi_sem;
#else
  avi_sem_ptr = dlsym(RTLD_DEFAULT,DL_UND("avi_sem"));
#endif
#endif

  if(avi_audio_stop && avi_audio_start && avi_extract_audiobuf
#ifndef NOTHAVE_SEM
     && avi_sem_ptr
#endif
     ) {
    avi2=avi;
  } else {
    avi2=0;
    fprintf(stderr,"@@@@ Warning: xawdecode is older than plug\n");
  }
  if(naudiofrags==-1) naudiofrags = avi2 ? 3 : 48;
  pthread_mutex_init (&divx_mutex, NULL);
  if(avi2)
    avi_audio_stop();
  else if (is_divx_in_progress())
    divx_audio_stop();
#ifdef _POSIX_THREAD_IS_GNU_PTH
  {
    pthread_attr_t attr;
    pthread_attr_init(&attr);
    /* increase if you have a "**Pth** STACK OVERFLOW" */
    pthread_attr_setstacksize(&attr, 256*1024);
    ret = pthread_create (&nagraudio_thread, &attr, nagraudio_main, (void *) arg);
    pthread_attr_destroy(&attr);
  }
#else
  ret = pthread_create (&nagraudio_thread, NULL, nagraudio_main, (void *) arg);
#endif
  if (debug)
    {
      if (ret == 0)
        printf ("Nagraudio started.\n");
      else
        printf ("Nagraudio start failed.\n");
    }
}

void
stop_nagraudio (void)
{
  void *ret;

  if (debug)
    printf ("Nagraudio stopped.\n");
  pthread_cancel (nagraudio_thread);
  if(avi2) 
#ifndef NOTHAVE_SEM
    sem_post(avi_sem_ptr);
#else
    pthread_mutex_unlock(avi_mut_video);
#endif
  pthread_join (nagraudio_thread, &ret);
#ifdef HAVE_OSS
  close_card ();
#endif
  if(avi2) 
    avi_audio_start();
  else  if(is_divx_in_progress())
    divx_audio_start();
  if(audiobuf) {free(audiobuf);audiobuf=NULL;}
  pthread_mutex_destroy(&divx_mutex);
}

#ifdef WRITE_TO_WAV
void
write_wav_header (int sfdes, int data_length)
{
  wavhead header;

  char *riff = "RIFF";
  char *wave = "WAVE";
  char *fmt = "fmt ";
  char *data = "data";

  fast_memcpy (&(header.main_chunk), riff, 4);
  header.length = sizeof (wavhead) - 8 + data_length;
  fast_memcpy (&(header.chunk_type), wave, 4);

  fast_memcpy (&(header.sub_chunk), fmt, 4);
  header.sc_len = 16;
  header.format = 1;
  header.modus = 0; /* 0 Mono, 1 Stereo */
  header.sample_fq = DEC_FREQ;
  header.byte_p_sec = ((bits > 8) ? 2 : 1) * header.modus * DEC_FREQ;
  header.byte_p_spl = (bits > 8) ? 2 : 1;
  header.bit_p_spl = bits;

  fast_memcpy (&(header.data_chunk), data, 4);
  header.data_length = data_length;
  write (sfdes, &header, sizeof (header));
}


int
open_sound_file (int type)
{
  int themask, sfdes;
  char filename[100] = "";
  char num[4] = "";
  char aux[100] = "";
  char ext[5];
  int i;

  if (type)
    strcpy (ext, ".wav");
  else
    strcpy (ext, ".raw");

  strcpy (filename, DEFAULT_FILE_PATH);
  strcat (filename, "/nagraudio");

  for (i = 0; i < 1000; i++)
    {
      sprintf (num, "%.3d", i);
      strcpy (aux, filename);
      strcat (aux, num);
      strcat (aux, ext);
      if (open (aux, O_RDONLY) == -1)
        break;
    }

  themask = umask (0);
  umask (themask);
  sfdes = open (aux, O_CREAT | O_TRUNC | O_WRONLY, (~themask) & 0666);

  if (sfdes == -1)
    fprintf (stderr, "Error opening sound file\n");
  else
    {
      printf ("Writing to %s ...\n", aux);
      if (type)
        write_wav_header (sfdes, 0);
    }

  return sfdes;

}

void
close_sound_file (int sfdes, int type, int writed_buf)
{
  if (type == 2)
    {
      lseek (sfdes, 0, SEEK_SET);
      write_wav_header (sfdes, writed_buf * SIZE_BUFFER * sizeof (short int));
    };
  close (sfdes);
}
#endif // WRITE_TO_WAV


void
error_exit (char *message, int number)
{
  pthread_setcancelstate(PTHREAD_CANCEL_ENABLE,NULL);
  pthread_testcancel (); // otherwise segfaults with -v 1 and alsa
  fprintf (stderr, "\n");
  fprintf (stderr, message);
  fprintf (stderr, "\nExiting Nagraudio thread.\n");
  pthread_exit ((void *) number);
}

#ifdef HAVE_ALSA
static void check_alsa_error(int err, char * msg) {
  if(err<0) {
    static char aux_string[100];
    sprintf (aux_string, "%s: %s\n", msg, snd_strerror (err));
    error_exit (aux_string, -1);
  }
}

static void alsa_configure(snd_pcm_t *handle,unsigned int *rate) {
  snd_pcm_hw_params_t *hw_params = NULL;
  int err;

  err = snd_pcm_nonblock(handle, 0);
  check_alsa_error(err,"snd_pcm_nonblock");
  snd_pcm_hw_params_alloca(&hw_params);
  err = snd_pcm_hw_params_any(handle, hw_params);
  check_alsa_error(err,"snd_pcm_hw_params_any");
  err = snd_pcm_hw_params_set_format(handle, hw_params, SND_PCM_FORMAT_S16_LE);
  check_alsa_error(err,"snd_pcm_hw_params_set_format");
  err = snd_pcm_hw_params_set_channels(handle, hw_params, 1);
  check_alsa_error(err,"snd_pcm_hw_params_set_channels");
  err = snd_pcm_hw_params_set_rate_near(handle, hw_params, *rate, 0);
  check_alsa_error(err,"snd_pcm_hw_params_set_rate_near");
  err = snd_pcm_hw_params_set_access(handle, hw_params,SND_PCM_ACCESS_RW_INTERLEAVED);
  check_alsa_error(err,"snd_pcm_hw_params_set_access");
  err = snd_pcm_hw_params_set_period_size_near(handle, hw_params, naudiofragsize, 0);
  check_alsa_error(err,"snd_pcm_hw_params_set_period_size_near");
  err = snd_pcm_hw_params_set_periods_near(handle, hw_params, naudiofrags, 0);
  check_alsa_error(err,"snd_pcm_hw_params_set_periods_near");
  err = snd_pcm_hw_params(handle, hw_params);
  check_alsa_error(err,"snd_pcm_hw_params");
  *rate = snd_pcm_hw_params_get_rate(hw_params, 0);
}

/* see alsa-driver/alsa-kernel/core/oss/pcm_oss.c/snd_pcm_oss_read3 */
static int alsa_read(void *buf, int nbframes) {
  int ret;
  while (1) {
    snd_pcm_state_t  state = snd_pcm_state(handle_in);
    if(debug>=2) fprintf(stderr,"state read=%d\n", state);
    if (state == SND_PCM_STATE_XRUN || 
	state == SND_PCM_STATE_SUSPENDED) {
      if(debug) fprintf(stderr, "alsa_read: snd_pcm_prepare\n");
      ret = snd_pcm_prepare(handle_in);
      if(debug>=2) fprintf(stderr, "ret_prepare ret=%d\n", ret);
      if (ret < 0)
	break;
    }
    ret = snd_pcm_readi (handle_in, buf, nbframes);
    if(debug>=2) fprintf(stderr,"ret_readi=%d\n",ret);
    if (ret != -EPIPE && ret != -ESTRPIPE)
      break;
  }
  return ret;
}

/* see alsa-driver/alsa-kernel/core/oss/pcm_oss.c/snd_pcm_oss_write3 */
static int alsa_write(void *buf, int nbframes) {
  int ret;
  while (1) {
    snd_pcm_state_t  state = snd_pcm_state(handle_out);
    if(debug>=2) fprintf(stderr,"state write=%d\n", state);
    if (state == SND_PCM_STATE_XRUN ||
	state == SND_PCM_STATE_SUSPENDED) {
      if(debug) fprintf(stderr, "alsa_write: snd_pcm_prepare\n");
      ret = snd_pcm_prepare(handle_out);
      if(debug>=2) fprintf(stderr, "ret_prepare write=%d\n",ret);
      if (ret < 0)
	break;
    }
    ret = snd_pcm_writei(handle_out, buf, nbframes);
    if(debug>=2) fprintf(stderr, "ret_writei=%d\n",ret);
    if (ret != -EPIPE && ret != -ESTRPIPE)
      break;
  }
  return ret;
}
#endif

#ifdef WORDS_BIGENDIAN
inline static void swap16(void *mem, int n) {
  char c, *p = (char *) mem;
  int i = n;
  while (i--) {
    c = p[0];
    p[0] = p[1];
    p[1] = c;
    p += 2;
  }
}
#endif

void
do_audio_decode_44 ()
{

  short int *pre_buffer_in, *aux1;
  short int *pre_buffer_out, *aux2;
  short int *post_buffer_in, *aux3;
  short int *post_buffer_out, *aux4;
  short int *modulation_in, *modulation_out, *aux5;
  short int *dec_table, *out;
  int i, iaudiobuf=0;
  int j, temp_out;                /* Filters variables */

  int k, pos, changes;            /* Auto decode */
  int inertia = 0;                /* variables */

#ifdef WRITE_TO_WAV
  int sfdes, writed_buf, writing = 0;    /* Sound file descriptor & writing flag */
#endif

  ssize_t r=0, w;
  struct timeval tv;
  int size_buffer;

  pre_buffer_in = malloc ((SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  memset (pre_buffer_in, 0, (SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  pre_buffer_in += MAX_ORDER;
  aux1 = pre_buffer_in;

  pre_buffer_out = malloc ((SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  memset (pre_buffer_out, 0, (SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  pre_buffer_out += MAX_ORDER;
  aux2 = pre_buffer_out;

  post_buffer_in = malloc ((SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  memset (post_buffer_in, 0, (SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  post_buffer_in += MAX_ORDER;
  aux3 = post_buffer_in;

  post_buffer_out = malloc ((SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  memset (post_buffer_out, 0, (SIZE_BUFFER + MAX_ORDER) * sizeof (short int));
  post_buffer_out += MAX_ORDER;
  aux4 = post_buffer_out;

  dec_table = malloc (SIZE_BUFFER * sizeof (short int));
  aux5 = dec_table;

  for (i = 0; i < SIZE_BUFFER; i++)
    *dec_table++ =
      (short
       int) ((cos
              (M_PI * (float) i *
               (2. * (float) NAGRA_FREQ / (float) DEC_FREQ)) *
              (1 << PRECISSION)) - 1);

#ifdef HAVE_OSS
#ifdef HAVE_ALSA
  if(have_alsa)
    prepare_card_alsa ();
  else
#endif
    prepare_card_oss (16);
#endif

  if(avi2) {audiobuf=malloc(200000);iaudiobuf=0;}
  while (1)
    {
#ifdef _POSIX_THREAD_IS_GNU_PTH
  pthread_yield_np();
#endif
      if(!avi2) {
#ifdef HAVE_OSS
#ifdef HAVE_ALSA
	if(have_alsa)
	  {
	    r = alsa_read (aux1, SIZE_BUFFER);
	    check_alsa_error(r, "Error reading device");
	    size_buffer = r;
	  }
	else
#endif
	  {
	    if ((r=read (fd, aux1, SIZE_BUFFER * sizeof (short int))) == -1)
	      error_exit ("Error reading device", 2);
	    size_buffer = r / sizeof(short);
	  }
#else
	error_exit("driver unsupported by plug audio", 2);
#endif
      } else {
	if(iaudiobuf>=r) {
	  r=avi_extract_audiobuf(audiobuf);iaudiobuf=0;
	}
	size_buffer = (r - iaudiobuf)/sizeof(short);
	if(size_buffer>SIZE_BUFFER) size_buffer=SIZE_BUFFER;
	aux1 = audiobuf+iaudiobuf;
	iaudiobuf += sizeof(short)*size_buffer;
      }
      if(debug>=2) printf("audioread=%d/%d\n",size_buffer,SIZE_BUFFER);

      gettimeofday (&tv, NULL);
      audiostamp=tv.tv_usec/1000000.0+tv.tv_sec;

#ifdef WORDS_BIGENDIAN
      swap16(aux1, size_buffer);
#endif

      /******************* AUTODECODE RUTINE *******************/
      if (auto_decode)
        {
          changes = 0;
          pos = *(aux1) > 0;
          for (k = 1; k < 20; k++)
            if (*(aux1 + k) > 10)
              {
                if (!pos)
                  {
                    changes++;
                    pos = 1;
                  }
              }
            else if (*(aux1 + k) < -10)
              if (pos)
                {
                  changes++;
                  pos = 0;
                }


          if (changes > 6)
            {
              if (inertia < 5)
                inertia++;
            }
          else if (inertia > -5)
            inertia--;

          decode = !(inertia < 0);
        }
      /************* END OF AUTODECODE RUTINE ****************/

      if (decode)
        {
      /**************** PRE MODULATION FILTER ******************/
          if (pre_filter_level)
            {
              pre_buffer_in = aux1;
              pre_buffer_out = aux2;

              for (i = 0; i < size_buffer; i++)
                {
                  temp_out = 0;

                  for (j = 1; j < pre_filter_level + 1; j++)
                    temp_out +=
                      pre_out_coef[pre_filter_level][j] * *(pre_buffer_out -
                                                            j);

                  temp_out = temp_out >> PRECISSION;

                  for (j = 1; j < pre_filter_level / 2 + 1; j++)
                    temp_out +=
                      in_coef[pre_filter_level][j] * (*(pre_buffer_in - j) +
                                                      *(pre_buffer_in -
                                                        pre_filter_level +
                                                        j));

                  *pre_buffer_in =
                    (*pre_buffer_in << PRECISSION) /
                    pre_gains[pre_filter_level];

                  temp_out +=
                    *(pre_buffer_in - pre_filter_level) + *pre_buffer_in;

                  pre_buffer_in++;
                  *pre_buffer_out++ = temp_out;
                }

              modulation_in = aux2;

              fast_memcpy (aux2 - MAX_ORDER, aux2 + size_buffer - MAX_ORDER,
                      MAX_ORDER * sizeof (short int));
              fast_memcpy (aux1 - MAX_ORDER, aux1 + size_buffer - MAX_ORDER,
                      MAX_ORDER * sizeof (short int));

            }
          else
            modulation_in = aux1;
      /************** END OF PRE MODULATION FILTER **************/

      /************** BEGIN OF MODULATION ******************/

          dec_table = aux5;
          modulation_out = aux3;

          /*
          if (have_MMX)
            {                    // use MMX

              pxor_r2r (mm7, mm7);
              movd_m2r (OUT_GAIN, mm7);

              for (i = 0; i < size_buffer; i += 4)
                {

                  movq_m2r (*modulation_in, mm0);    // data
                  movq_m2r (*dec_table, mm1);

                  movq_r2r (mm0, mm2);
                  pmullw_r2r (mm1, mm0);
                  pmulhw_r2r (mm2, mm1);

                  movq_r2r (mm0, mm2);
                  punpcklwd_r2r (mm1, mm0);
                  punpckhwd_r2r (mm1, mm2);
                  psrad_i2r (PRECISSION, mm0);
                  psrad_i2r (PRECISSION, mm2);
                  pslld_r2r (mm7, mm0);
                  pslld_r2r (mm7, mm2);

                  packssdw_r2r (mm2, mm0);
                  movq_r2m (mm0, *modulation_out);

                  modulation_out += 4;
                  modulation_in += 4;
                  dec_table += 4;
                }
              emms ();

            }
          else
*/
            for (i = 0; i < size_buffer; i++)
              *modulation_out++ =
                (*modulation_in++ ** dec_table++) >> (PRECISSION - OUT_GAIN);

      /************** END OF MODULATION ********************/

      /******************* POST MODULATION FILTER *****************/
          if (post_filter_level)
            {
              post_buffer_in = aux3;
              post_buffer_out = aux4;

              for (i = 0; i < size_buffer; i++)
                {
                  temp_out = 0;

                  for (j = 1; j < post_filter_level + 1; j++)
                    temp_out +=
                      post_out_coef[post_filter_level][j] *
                      *(post_buffer_out - j);

                  temp_out = temp_out >> PRECISSION;

                  for (j = 1; j < post_filter_level / 2 + 1; j++)
                    temp_out +=
                      in_coef[post_filter_level][j] * (*(post_buffer_in - j) +
                                                       *(post_buffer_in -
                                                         post_filter_level +
                                                         j));

                  *post_buffer_in =
                    (*post_buffer_in << PRECISSION) /
                    post_gains[post_filter_level];

                  temp_out +=
                    *(post_buffer_in - post_filter_level) + *post_buffer_in;

                  post_buffer_in++;
                  *post_buffer_out++ = temp_out;
                }

              out = aux4;

              fast_memcpy (aux3 - MAX_ORDER, aux3 + size_buffer - MAX_ORDER,
                      MAX_ORDER * sizeof (short int));
              fast_memcpy (aux4 - MAX_ORDER, aux4 + size_buffer - MAX_ORDER,
                      MAX_ORDER * sizeof (short int));

            }
          else
            out = aux3;
      /*************** END OF POST MODULATION FILTER **************/

        }
      else
        {
          fast_memcpy (aux4, aux1, size_buffer * sizeof (short int));
          out = aux4;
        }

#ifdef WORDS_BIGENDIAN
      swap16(out, size_buffer);
#endif
      if(!noaudioout) {
#ifdef HAVE_OSS
#ifdef HAVE_ALSA
	if(have_alsa)
	  {
	    w = alsa_write (out, size_buffer);
	    check_alsa_error(w, "Error writing device");
	  }
	else
#endif
	  {
	    if ((w=write (fd, out, size_buffer * sizeof (short int))) == -1)
	      error_exit ("Error writing device", 2);
	  }
	if(debug>=2) printf("audiowrite=%d/%d\n",w,size_buffer);
#endif
      }
      pthread_mutex_lock(&divx_mutex);
      if (is_divx_in_progress())
        write_audio_to_avi(out, size_buffer);
      pthread_mutex_unlock(&divx_mutex);

#ifdef WRITE_TO_WAV
      if (writing)
        {
          if (write (sfdes, out, size_buffer * sizeof (short int)) == -1)
            {
              error_exit ("Error writing file", 2);
            }
          else
            {
              writed_buf++;
            }
        }
#endif
      if(!avi2) {
	pthread_setcancelstate(PTHREAD_CANCEL_ENABLE,NULL);
	pthread_testcancel ();
	pthread_setcancelstate(PTHREAD_CANCEL_DISABLE,NULL);
      }
    }

}


void
do_audio_decode_8 ()
{
#ifdef HAVE_OSS
  unsigned char buffer[SIZE_BUFFER];
  unsigned char dec_table[256];
  int i,r;

  for (i = 0; i < 256; i++)
    dec_table[i] = 255 - i;

  prepare_card_oss (8);

  while (1)
    {
      if ((r=read (fd, buffer, SIZE_BUFFER)) == -1)
        perror ("read");

      for (i = 0; i < r; i += 2)
        buffer[i] = dec_table[buffer[i]];

      if (r>0 && write (fd, buffer, r) == -1)
        perror ("write");

      pthread_setcancelstate(PTHREAD_CANCEL_ENABLE,NULL);
      pthread_testcancel ();
      pthread_setcancelstate(PTHREAD_CANCEL_DISABLE,NULL);
    }
#else
  fprintf(stderr, "decode8 not implemented with this driver\n");
  exit(1);
#endif
}

#ifdef HAVE_OSS
#ifdef HAVE_ALSA
int
prepare_card_alsa ()
{
  int err, rate_in = DEC_FREQ, rate_out = DEC_FREQ;

  if (debug)
    fprintf(stderr, "prepare_card_alsa\n");

  if(!noaudioout) {
    err = snd_pcm_open (&handle_out, "default", SND_PCM_STREAM_PLAYBACK, 0);
    check_alsa_error(err, "snd_pcm_open out");
    alsa_configure(handle_out, &rate_out);
  }
  if(!avi2) {
    err = snd_pcm_open (&handle_in, "default", SND_PCM_STREAM_CAPTURE, 0);
    check_alsa_error(err, "snd_pcm_open in");
    alsa_configure(handle_in, &rate_in);
  }
  if(!avi2 && !noaudioout) {
    if(rate_in != rate_out) {
      if(debug)
	fprintf(stderr, "ALSA RATE_IN=%d RATE_OUT=%d\n",rate_in, rate_out);
      if(rate_out != DEC_FREQ) {
	rate_in = rate_out;
	alsa_configure(handle_in, &rate_in);
      } else {
	rate_out = rate_in;
	alsa_configure(handle_out, &rate_out);
      }
      if(debug)
	fprintf(stderr, "ALSA RATE_IN=%d RATE_OUT=%d\n",rate_in, rate_out);
    }
  }
  if(!noaudioout) {
    err = snd_pcm_prepare(handle_out);
    check_alsa_error(err, "snd_pcm_prepare out");
  }
  if(!avi2) {
    err = snd_pcm_prepare(handle_in);
    check_alsa_error(err, "snd_pcm_prepare in");
  }
  if(debug) {
    snd_output_t *log;
    snd_output_stdio_attach(&log, stderr, 0);
    if(!avi2) {
      snd_pcm_dump_hw_setup(handle_in, log);
      snd_pcm_dump_sw_setup(handle_in, log);
    }
    if(!noaudioout) {
      snd_pcm_dump_hw_setup(handle_out, log);
      snd_pcm_dump_sw_setup(handle_out, log);
    }
    snd_output_close(log);
  }
  return 0;
}


#endif

int
prepare_card_oss (int bits)
{
#ifndef HAVE_SUNAUDIO
  int aux, caps;
#else
  audio_info_t info;
#endif

  if (debug)
    fprintf(stderr, "prepare_card_oss\n");
  
  if(avi2 && noaudioout) return 0;

  if(!avi2 && !noaudioout) {
    fd = open (device, O_RDWR);
    if (fd < 0) {
      perror("open");
      fprintf(stderr, "impossible to open %s\n",device);
      error_exit ("Error opening audio device", -1);
    }
    
#ifndef HAVE_SUNAUDIO
#ifndef __FreeBSD__
    if (ioctl (fd, SNDCTL_DSP_SETDUPLEX, 0) == -1)
      error_exit ("Error with full duplex setup\n", -1);
#endif
    
    if (ioctl (fd, SNDCTL_DSP_GETCAPS, &caps) == -1)
      error_exit ("Sorry but your sound driver is too old\n", -1);
    
    if (!(caps & DSP_CAP_DUPLEX))
      error_exit ("Sorry but your soundcard can't do full duplex\n", -1);
#endif
  }
  else if(avi2)
    fd = open (device, O_WRONLY);
  else
    fd = open (device, O_RDONLY);
  
#ifndef HAVE_SUNAUDIO
  aux = ((int)(log(naudiofragsize)/log(2)+0.5)) | (naudiofrags<<16);
  if (ioctl (fd, SNDCTL_DSP_SETFRAGMENT, &aux) == -1)
    error_exit ("Error setting audio fragments", -1);

  if (bits == 8)
    aux = AFMT_U8;
  else
    aux = AFMT_S16_LE;

  if (ioctl (fd, SNDCTL_DSP_SETFMT, &aux) == -1)
    error_exit ("Error setting audio format (bits)", -1);

  aux = 0; /* 0 Mono, 1 Stereo */
  if (ioctl (fd, SNDCTL_DSP_STEREO, &aux) == -1)
    error_exit ("Error setting audio format (stereo)", -1);

  aux = DEC_FREQ;
  if (ioctl (fd, SNDCTL_DSP_SPEED, &aux) == -1)
    error_exit ("Error setting audio format (frequency)", -1);
#else
  ioctl(fd, AUDIO_DRAIN, 0);
  AUDIO_INITINFO (&info);
  info.play.sample_rate=info.record.sample_rate = DEC_FREQ;
  info.blocksize = naudiofragsize;
  info.hiwat = naudiofrags;
  info.mode = 0; 
  if(!avi2) info.mode |= AUMODE_RECORD;
  if(!noaudioout) info.mode |= (AUMODE_PLAY | AUMODE_PLAY_ALL);
  info.play.channels=info.record.channels = 1;
  info.play.precision=info.record.precision = bits;
  if(bits==8)
    info.play.encoding=info.record.encoding = AUDIO_ENCODING_SLINEAR_LE;
  else
    info.play.encoding=info.record.encoding = AUDIO_ENCODING_SLINEAR;
  info.record.port = AUDIO_LINE_IN;
  if (ioctl (fd, AUDIO_SETINFO, &info) == -1) {
    perror("AUDIO_SETINFO");
    error_exit ("PB SETINFO", -1);
  }
  if(!avi2 && !noaudioout) {
    int arg=1;
    if(ioctl (fd, AUDIO_SETFD, &arg) == -1) {
      perror("AUDIOSETFD");
      error_exit("impossible to set full duplex mode", -1);
    }
  }
#endif

  return 0;
}


void
close_card (void)
{
#if defined(HAVE_OSS) && defined(HAVE_ALSA)
  if(have_alsa)
    {
      if(handle_in) snd_pcm_close (handle_in);
      if(handle_out) snd_pcm_close (handle_out);
      handle_in = handle_out = NULL;
      return;
    }
#endif
  if(fd!=-1) close (fd);
  fd = -1;
}
#endif


void
read_nagraudio_config (void)
{
  FILE *fp;
  char filename[100], line[100], tag[32], val[100], *h;
  int nr = 0;

  sprintf (filename, "%s/%s", getenv ("HOME"), ".nagraudiorc");

  fp = fopen (filename, "r");

  if (NULL == fp)
    fp = fopen ("/etc/nagraudiorc", "r");

  if (NULL == fp)
    {
      fprintf (stderr, "Can't open config file, using defaults\n\n");
      return;
    }

  while (NULL != fgets (line, 99, fp))
    {
      nr++;
      if (line[0] == '\n' || line[0] == '#' || line[0] == '%')
        continue;
      if (2 != sscanf (line, " %31[^= ] = %99[^\n]", tag, val))
        {
          fprintf (stderr, "%s:%d: parse error\n", filename, nr);
          continue;
        }

      for (h = val + strlen (val); h > val && *h == ' '; h--)
        *h = '\0';

      parse_nagraudio_config_line (tag, val, filename, nr);

    }
}

void
parse_nagraudio_config_line (char *tag, char *val, char *filename, int nr)
{
  //printf("In file %s at line %d: parsing Nagraudio parameter: %s = %s\n", filename, nr, tag, val);
  if (0 == strcmp (tag, "pre_filter"))
    if (atoi (val) != 0)
      if (atoi (val) < 1 || atoi (val) > MAX_ORDER / 2 + 1)
        fprintf (stderr, "%s:%d: wrong valor in %s\n", filename, nr, tag);
      else
        pre_filter_level = (atoi (val)) * 2 - 1;
    else
      pre_filter_level = 0;

  else if (0 == strcmp (tag, "post_filter"))
    if (atoi (val) != 0)
      if (atoi (val) < 1 || atoi (val) > MAX_ORDER / 2 + 1)
        fprintf (stderr, "%s:%d: wrong valor in %s\n", filename, nr, tag);
      else
        post_filter_level = (atoi (val)) * 2 - 1;
    else
      post_filter_level = 0;

  else if (0 == strcmp (tag, "output_gain"))
    if (atoi (val) != 0)
      if (atoi (val) < 1 || atoi (val) > MAX_GAIN)
        fprintf (stderr, "%s:%d: wrong valor in %s\n", filename, nr, tag);
      else
        OUT_GAIN = atoi (val);
    else
      OUT_GAIN = 0;

  else if (0 == strcmp (tag, "device"))
    strcpy (device, val);

  else if (0 == strcmp (tag, "auto_decode"))
    if (atoi (val) == 0)
      auto_decode = 0;
    else if (atoi (val) == 1)
      auto_decode = 1;
    else
      fprintf (stderr, "%s:%d: wrong valor in %s\n", filename, nr, tag);

  /*
     else if (0 == strcmp(tag,"gui"))
     if (atoi(val)==0)
     gui=0;
     else if (atoi(val)==1)
     gui=1;
     else
     fprintf(stderr,"%s:%d: wrong valor in %s\n",filename,nr,tag);
   */

  else if (0 == strcmp (tag, "8_bits"))
    if (atoi (val) == 0)
      bits = 16;
    else if (atoi (val) == 1)
      bits = 8;
    else
      fprintf (stderr, "%s:%d: wrong valor in %s\n", filename, nr, tag);

  else
    {
      fprintf (stderr, "%s:%d: unknown option %s\n", filename, nr, tag);
    }
}

void
save_nagraudio_config (FILE * fp)
{
  char *prefix = "nagraudio.";
  int val;

  if (fp == (FILE *) NULL)
    return;

  fprintf (fp, "#\n");
  fprintf (fp, "# Nagraudio configuration file\n");
  fprintf (fp, "# see Readme for more details\n");
  fprintf (fp, "#\n");
  fprintf (fp, "# 1: Decode in 8 bits mode ; 0: Use 16 bits mode\n");
  fprintf (fp, "%s8_bits = %d\n\n", prefix, (bits == 16) ? 0 : 1);

  fprintf (fp, "# Audio device to use\n");
  fprintf (fp, "%sdevice = %s\n\n", prefix, device);

  fprintf (fp, "# 1: Automatic decoding ; 0: Always decoding\n");
  fprintf (fp, "%sauto_decode = %d\n\n", prefix, auto_decode);

  fprintf (fp, "# 0: Disabled ; [1..4]: Level of filter to use\n");
  if (pre_filter_level == 0)
    val = 0;
  else
    val = (pre_filter_level + 1) / 2;
  fprintf (fp, "%spre_filter = %d\n\n", prefix, val);

  fprintf (fp, "# 0: Disabled ; [1..4]: Level of filter to use\n");
  if (post_filter_level == 0)
    val = 0;
  else
    val = (post_filter_level + 1) / 2;
  fprintf (fp, "%spost_filter = %d\n\n", prefix, val);

  fprintf (fp, "# 0: Disabled; 1: Output x2 ; 2: Output x4 ; 3: Output x8\n");
  fprintf (fp, "%soutput_gain = %d\n\n", prefix, OUT_GAIN);

}


void *
nagraudio_main (void *arg)
{
  int use_config = (int) arg;

  //printf("nagraudio_main: parameter value is: %d\n", use_config);

  pthread_setcancelstate(PTHREAD_CANCEL_DISABLE,NULL);
  if (use_config)
    read_nagraudio_config ();

  if (bits == 8)
    {
      DEC_FREQ=25600;
      if(avi2) {
	fprintf(stderr, "nagraudio: 8 bits not implemented with avi\n");
	exit(1);
      }
#if defined(HAVE_OSS) && defined(HAVE_ALSA)
      if(have_alsa)
	error_exit("nagraudio: 8 bits not implemented with alsa",2);
#endif
    }
  else
    DEC_FREQ=44100;

  //printf("Nagraudio version %s\n", NAGRAUDIO_VERSION);
  if (debug)
    {
      printf ("Nagraudio version %s\n", NAGRAUDIO_VERSION);
      printf ("Sampling %d hz %d bits\n\n", DEC_FREQ, bits);

      if (!use_config)
        printf ("Ignoring configuration file\n");

      if(bits != 8) {
	if (post_filter_level)
	  printf ("Using post filter of level %d\n", post_filter_level / 2 + 1);
	if (pre_filter_level)
	  printf ("Using pre filter of level %d\n", pre_filter_level / 2 + 1);
	if (auto_decode)
	  printf ("Automatic decoding enabled.\n");
	if (OUT_GAIN)
	  printf ("Using output gain of level %d (x%d)\n", OUT_GAIN,
		  1 << OUT_GAIN);
      }
    }

  if (bits == 8)
    do_audio_decode_8 ();
  else
    do_audio_decode_44 ();

  return NULL;

}

void
set_nagraudio_auto_mode (int j)
{
  if ((j >= 0) && (j <= 1))
    auto_decode = j;
}

int
get_nagraudio_auto_mode (void)
{
  return auto_decode;
}

void
set_nagraudio_pre_filter (int j)
{
  if ((j >= 0) && (j <= 4))
    {
      if (j == 0)
        pre_filter_level = 0;
      else
        pre_filter_level = j * 2 - 1;
    }
}

int
get_nagraudio_pre_filter (void)
{
  return (pre_filter_level + 1) / 2;
}

void
set_nagraudio_post_filter (int j)
{
  if ((j >= 0) && (j <= 4))
    {
      if (j == 0)
        post_filter_level = 0;
      else
        post_filter_level = j * 2 - 1;
    }
}

int
get_nagraudio_post_filter (void)
{
  return (post_filter_level + 1) / 2;
}

void
set_nagraudio_gain (int j)
{
  if ((j >= 0) && (j <= 3))
    OUT_GAIN = j;
}

int
get_nagraudio_gain (void)
{
  return OUT_GAIN;
}

void
set_nagraudio_bit_mode (int j)
{

  switch (j)
    {
    case 0:
      bits = 16;
      break;
    case 1:
      bits = 8;
      /*
         pre_filter_level=0;
         post_filter_level=0;
         OUT_GAIN=0;
         auto_decode=0;      
       */
      break;
    default:
      break;
    }

}

int
get_nagraudio_bit_mode (void)
{
  if (bits == 8)
    return 1;
  else
    return 0;
}

void
wait_write_audio(void)
{
  pthread_mutex_lock(&divx_mutex);
  pthread_mutex_unlock(&divx_mutex);
}
